# debug info seem not works with D compiler
%global debug_package %{nil}

Name:           DCD
Version:        0.9.13
Release:        1%{?dist}
Summary:        The D Completion Daemon is an auto-complete program for the D programming language
Summary(fr):    Le démon pour la complétion D est un program d'auto-complétion pour le language de programmation D

License:        GPLv3
URL:            https://github.com/dlang-community/DCD
# curl -LoDCD-%%{version}%%{?pre:-%%{pre}}.tar.gz https://github.com/dlang-community/DCD/archive/v%%{version}%%{?pre:-%%{pre}}.tar.gz
Source0:        %{name}-%{version}%{?pre:-%{pre}}.tar.gz

BuildRequires:  ldc ldc-phobos-devel stdx-allocator-devel msgpack-d-devel dsymbol-devel
BuildRequires:  libdparse-devel containers-devel
Requires:       ldc-druntime ldc-phobos
Requires:       stdx-allocator msgpack-d dsymbol libdparse

%description
DCD is not an IDE. DCD is designed to provide autocompletion for your favorite
text editor. DCD consists of a client and a server. The client (dcd-client) is
almost always used through a text editor script or plugin, though it can be
used from the command line. The server (dcd-server) is responsible for
caching imported files, calculating autocomplete information, and sending it
back to the client.

%description -l fr_FR
DCD n'est pas un IDE. DCD est conçu pour finir l'auto-complétion pour votre
éditeur cd texte favoris. DCD consiste d'un client et d'un serveur. Le client
(dcd-client) est pratiquement tout le temps utilisé à travers un éditeur de 
script ou un module additionnel, cependant il peut être utilisé à partir de
la ligne de commande. Le serveur (dcd-serveur) est responsable de la mise en 
cache des fichiers importés, du calul des informations d'auto-complétion puis
de renvoyer le tout au client.

%prep
%autosetup

install -d bin
echo 'v0.9.10' > bin/githash.txt
rm -fr msgpack-d containers dsymbol libdparse

%build
DFLAGS='-w -release -g -O2'
commons=$(find src/dcd/common -name '*.d')
clients=$(find src/dcd/client -name '*.d')
servers=$(find src/dcd/server -name '*.d')
ldc2 ${commons[@]} ${clients[@]}  ${DFLAGS} -I%{_d_includedir}/msgpack -L-lmsgpack-d -Jbin -of=bin/dcd-client
ldc2 ${commons[@]} ${servers[@]}  ${DFLAGS} \
        -I%{_d_includedir}/dsymbol -L-ldsymbol \
        -I%{_d_includedir}/dparse -L-ldparse \
        -I%{_d_includedir}/containers -L-ldcontainers \
        -I%{_d_includedir}/stdx-allocator -L-lstdx-allocator \
        -I%{_d_includedir}/msgpack -L-lmsgpack-d \
        -Jbin -of=bin/dcd-server


%install
install -d %{buildroot}/%{_bindir}/
install -m0755 bin/dcd-client %{buildroot}/%{_bindir}/dcd-client
install -m0755 bin/dcd-server %{buildroot}/%{_bindir}/dcd-server


%files
%license License.txt
#%%doc add-docs-here
%{_bindir}/dcd-client
%{_bindir}/dcd-server

%changelog
* Tue Jul 31 2018 MERCIER Jonathan <bioinfornatics at gmail.com> - 0.9.10-1
- Initiale release
